/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.inkwell.internet.shopping.sb.model;

import com.liferay.portal.kernel.annotation.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

/**
 * The base model interface for the ShoppingCategoryImage service. Represents a row in the &quot;Inkwell_ShoppingCategoryImage&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.inkwell.internet.shopping.sb.model.impl.ShoppingCategoryImageModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.inkwell.internet.shopping.sb.model.impl.ShoppingCategoryImageImpl}.
 * </p>
 *
 * <p>
 * Never modify or reference this interface directly. All methods that expect a shopping category image model instance should use the {@link ShoppingCategoryImage} interface instead.
 * </p>
 *
 * @author Rich Sezov
 * @see ShoppingCategoryImage
 * @see com.inkwell.internet.shopping.sb.model.impl.ShoppingCategoryImageImpl
 * @see com.inkwell.internet.shopping.sb.model.impl.ShoppingCategoryImageModelImpl
 * @generated
 */
public interface ShoppingCategoryImageModel extends BaseModel<ShoppingCategoryImage> {
	/**
	 * Gets the primary key of this shopping category image.
	 *
	 * @return the primary key of this shopping category image
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this shopping category image
	 *
	 * @param pk the primary key of this shopping category image
	 */
	public void setPrimaryKey(long pk);

	/**
	 * Gets the image id of this shopping category image.
	 *
	 * @return the image id of this shopping category image
	 */
	public long getImageId();

	/**
	 * Sets the image id of this shopping category image.
	 *
	 * @param imageId the image id of this shopping category image
	 */
	public void setImageId(long imageId);

	/**
	 * Gets the category id of this shopping category image.
	 *
	 * @return the category id of this shopping category image
	 */
	public long getCategoryId();

	/**
	 * Sets the category id of this shopping category image.
	 *
	 * @param categoryId the category id of this shopping category image
	 */
	public void setCategoryId(long categoryId);

	/**
	 * Gets the image url of this shopping category image.
	 *
	 * @return the image url of this shopping category image
	 */
	@AutoEscape
	public String getImageUrl();

	/**
	 * Sets the image url of this shopping category image.
	 *
	 * @param imageUrl the image url of this shopping category image
	 */
	public void setImageUrl(String imageUrl);

	/**
	 * Gets a copy of this shopping category image as an escaped model instance by wrapping it with an {@link com.liferay.portal.kernel.bean.AutoEscapeBeanHandler}.
	 *
	 * @return the escaped model instance
	 * @see com.liferay.portal.kernel.bean.AutoEscapeBeanHandler
	 */
	public ShoppingCategoryImage toEscapedModel();

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public void setEscapedModel(boolean escapedModel);

	public Serializable getPrimaryKeyObj();

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(ShoppingCategoryImage shoppingCategoryImage);

	public int hashCode();

	public String toString();

	public String toXmlString();
}