/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.inkwell.internet.productregistration.model;

import com.liferay.portal.kernel.annotation.AutoEscape;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

/**
 * The base model interface for the PRProduct service. Represents a row in the &quot;PR_PRProduct&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.inkwell.internet.productregistration.model.impl.PRProductModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.inkwell.internet.productregistration.model.impl.PRProductImpl}.
 * </p>
 *
 * <p>
 * Never modify or reference this interface directly. All methods that expect a p r product model instance should use the {@link PRProduct} interface instead.
 * </p>
 *
 * @author Rich Sezov
 * @see PRProduct
 * @see com.inkwell.internet.productregistration.model.impl.PRProductImpl
 * @see com.inkwell.internet.productregistration.model.impl.PRProductModelImpl
 * @generated
 */
public interface PRProductModel extends BaseModel<PRProduct> {
	/**
	 * Gets the primary key of this p r product.
	 *
	 * @return the primary key of this p r product
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this p r product
	 *
	 * @param pk the primary key of this p r product
	 */
	public void setPrimaryKey(long pk);

	/**
	 * Gets the product id of this p r product.
	 *
	 * @return the product id of this p r product
	 */
	public long getProductId();

	/**
	 * Sets the product id of this p r product.
	 *
	 * @param productId the product id of this p r product
	 */
	public void setProductId(long productId);

	/**
	 * Gets the product name of this p r product.
	 *
	 * @return the product name of this p r product
	 */
	@AutoEscape
	public String getProductName();

	/**
	 * Sets the product name of this p r product.
	 *
	 * @param productName the product name of this p r product
	 */
	public void setProductName(String productName);

	/**
	 * Gets the serial number of this p r product.
	 *
	 * @return the serial number of this p r product
	 */
	@AutoEscape
	public String getSerialNumber();

	/**
	 * Sets the serial number of this p r product.
	 *
	 * @param serialNumber the serial number of this p r product
	 */
	public void setSerialNumber(String serialNumber);

	/**
	 * Gets the company id of this p r product.
	 *
	 * @return the company id of this p r product
	 */
	public long getCompanyId();

	/**
	 * Sets the company id of this p r product.
	 *
	 * @param companyId the company id of this p r product
	 */
	public void setCompanyId(long companyId);

	/**
	 * Gets the group id of this p r product.
	 *
	 * @return the group id of this p r product
	 */
	public long getGroupId();

	/**
	 * Sets the group id of this p r product.
	 *
	 * @param groupId the group id of this p r product
	 */
	public void setGroupId(long groupId);

	/**
	 * Gets a copy of this p r product as an escaped model instance by wrapping it with an {@link com.liferay.portal.kernel.bean.AutoEscapeBeanHandler}.
	 *
	 * @return the escaped model instance
	 * @see com.liferay.portal.kernel.bean.AutoEscapeBeanHandler
	 */
	public PRProduct toEscapedModel();

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public void setEscapedModel(boolean escapedModel);

	public Serializable getPrimaryKeyObj();

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(PRProduct prProduct);

	public int hashCode();

	public String toString();

	public String toXmlString();
}