/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.inkwell.internet.productregistration.model;

import com.liferay.portal.kernel.annotation.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the PRUser service. Represents a row in the &quot;PR_PRUser&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.inkwell.internet.productregistration.model.impl.PRUserModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.inkwell.internet.productregistration.model.impl.PRUserImpl}.
 * </p>
 *
 * <p>
 * Never modify or reference this interface directly. All methods that expect a p r user model instance should use the {@link PRUser} interface instead.
 * </p>
 *
 * @author Rich Sezov
 * @see PRUser
 * @see com.inkwell.internet.productregistration.model.impl.PRUserImpl
 * @see com.inkwell.internet.productregistration.model.impl.PRUserModelImpl
 * @generated
 */
public interface PRUserModel extends BaseModel<PRUser> {
	/**
	 * Gets the primary key of this p r user.
	 *
	 * @return the primary key of this p r user
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this p r user
	 *
	 * @param pk the primary key of this p r user
	 */
	public void setPrimaryKey(long pk);

	/**
	 * Gets the pr user id of this p r user.
	 *
	 * @return the pr user id of this p r user
	 */
	public long getPrUserId();

	/**
	 * Sets the pr user id of this p r user.
	 *
	 * @param prUserId the pr user id of this p r user
	 */
	public void setPrUserId(long prUserId);

	/**
	 * Gets the pr user uuid of this p r user.
	 *
	 * @return the pr user uuid of this p r user
	 * @throws SystemException if a system exception occurred
	 */
	public String getPrUserUuid() throws SystemException;

	/**
	 * Sets the pr user uuid of this p r user.
	 *
	 * @param prUserUuid the pr user uuid of this p r user
	 */
	public void setPrUserUuid(String prUserUuid);

	/**
	 * Gets the first name of this p r user.
	 *
	 * @return the first name of this p r user
	 */
	@AutoEscape
	public String getFirstName();

	/**
	 * Sets the first name of this p r user.
	 *
	 * @param firstName the first name of this p r user
	 */
	public void setFirstName(String firstName);

	/**
	 * Gets the last name of this p r user.
	 *
	 * @return the last name of this p r user
	 */
	@AutoEscape
	public String getLastName();

	/**
	 * Sets the last name of this p r user.
	 *
	 * @param lastName the last name of this p r user
	 */
	public void setLastName(String lastName);

	/**
	 * Gets the address1 of this p r user.
	 *
	 * @return the address1 of this p r user
	 */
	@AutoEscape
	public String getAddress1();

	/**
	 * Sets the address1 of this p r user.
	 *
	 * @param address1 the address1 of this p r user
	 */
	public void setAddress1(String address1);

	/**
	 * Gets the address2 of this p r user.
	 *
	 * @return the address2 of this p r user
	 */
	@AutoEscape
	public String getAddress2();

	/**
	 * Sets the address2 of this p r user.
	 *
	 * @param address2 the address2 of this p r user
	 */
	public void setAddress2(String address2);

	/**
	 * Gets the city of this p r user.
	 *
	 * @return the city of this p r user
	 */
	@AutoEscape
	public String getCity();

	/**
	 * Sets the city of this p r user.
	 *
	 * @param city the city of this p r user
	 */
	public void setCity(String city);

	/**
	 * Gets the state of this p r user.
	 *
	 * @return the state of this p r user
	 */
	@AutoEscape
	public String getState();

	/**
	 * Sets the state of this p r user.
	 *
	 * @param state the state of this p r user
	 */
	public void setState(String state);

	/**
	 * Gets the postal code of this p r user.
	 *
	 * @return the postal code of this p r user
	 */
	@AutoEscape
	public String getPostalCode();

	/**
	 * Sets the postal code of this p r user.
	 *
	 * @param postalCode the postal code of this p r user
	 */
	public void setPostalCode(String postalCode);

	/**
	 * Gets the country of this p r user.
	 *
	 * @return the country of this p r user
	 */
	@AutoEscape
	public String getCountry();

	/**
	 * Sets the country of this p r user.
	 *
	 * @param country the country of this p r user
	 */
	public void setCountry(String country);

	/**
	 * Gets the phone number of this p r user.
	 *
	 * @return the phone number of this p r user
	 */
	@AutoEscape
	public String getPhoneNumber();

	/**
	 * Sets the phone number of this p r user.
	 *
	 * @param phoneNumber the phone number of this p r user
	 */
	public void setPhoneNumber(String phoneNumber);

	/**
	 * Gets the email of this p r user.
	 *
	 * @return the email of this p r user
	 */
	@AutoEscape
	public String getEmail();

	/**
	 * Sets the email of this p r user.
	 *
	 * @param email the email of this p r user
	 */
	public void setEmail(String email);

	/**
	 * Gets the birth date of this p r user.
	 *
	 * @return the birth date of this p r user
	 */
	public Date getBirthDate();

	/**
	 * Sets the birth date of this p r user.
	 *
	 * @param birthDate the birth date of this p r user
	 */
	public void setBirthDate(Date birthDate);

	/**
	 * Gets the male of this p r user.
	 *
	 * @return the male of this p r user
	 */
	public boolean getMale();

	/**
	 * Determines if this p r user is male.
	 *
	 * @return <code>true</code> if this p r user is male; <code>false</code> otherwise
	 */
	public boolean isMale();

	/**
	 * Sets whether this {$entity.humanName} is male.
	 *
	 * @param male the male of this p r user
	 */
	public void setMale(boolean male);

	/**
	 * Gets the user id of this p r user.
	 *
	 * @return the user id of this p r user
	 */
	public long getUserId();

	/**
	 * Sets the user id of this p r user.
	 *
	 * @param userId the user id of this p r user
	 */
	public void setUserId(long userId);

	/**
	 * Gets the user uuid of this p r user.
	 *
	 * @return the user uuid of this p r user
	 * @throws SystemException if a system exception occurred
	 */
	public String getUserUuid() throws SystemException;

	/**
	 * Sets the user uuid of this p r user.
	 *
	 * @param userUuid the user uuid of this p r user
	 */
	public void setUserUuid(String userUuid);

	/**
	 * Gets the company id of this p r user.
	 *
	 * @return the company id of this p r user
	 */
	public long getCompanyId();

	/**
	 * Sets the company id of this p r user.
	 *
	 * @param companyId the company id of this p r user
	 */
	public void setCompanyId(long companyId);

	/**
	 * Gets the group id of this p r user.
	 *
	 * @return the group id of this p r user
	 */
	public long getGroupId();

	/**
	 * Sets the group id of this p r user.
	 *
	 * @param groupId the group id of this p r user
	 */
	public void setGroupId(long groupId);

	/**
	 * Gets a copy of this p r user as an escaped model instance by wrapping it with an {@link com.liferay.portal.kernel.bean.AutoEscapeBeanHandler}.
	 *
	 * @return the escaped model instance
	 * @see com.liferay.portal.kernel.bean.AutoEscapeBeanHandler
	 */
	public PRUser toEscapedModel();

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public void setEscapedModel(boolean escapedModel);

	public Serializable getPrimaryKeyObj();

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(PRUser prUser);

	public int hashCode();

	public String toString();

	public String toXmlString();
}