/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.inkwell.internet.productregistration.model.impl;

import com.inkwell.internet.productregistration.model.PRRegistration;
import com.inkwell.internet.productregistration.model.PRRegistrationModel;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import java.io.Serializable;

import java.lang.reflect.Proxy;

import java.sql.Types;

import java.util.Date;

/**
 * The base model implementation for the PRRegistration service. Represents a row in the &quot;PR_PRRegistration&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link com.inkwell.internet.productregistration.model.PRRegistrationModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link PRRegistrationImpl}.
 * </p>
 *
 * <p>
 * Never modify or reference this class directly. All methods that expect a p r registration model instance should use the {@link com.inkwell.internet.productregistration.model.PRRegistration} interface instead.
 * </p>
 *
 * @author Rich Sezov
 * @see PRRegistrationImpl
 * @see com.inkwell.internet.productregistration.model.PRRegistration
 * @see com.inkwell.internet.productregistration.model.PRRegistrationModel
 * @generated
 */
public class PRRegistrationModelImpl extends BaseModelImpl<PRRegistration>
	implements PRRegistrationModel {
	public static final String TABLE_NAME = "PR_PRRegistration";
	public static final Object[][] TABLE_COLUMNS = {
			{ "registrationId", new Integer(Types.BIGINT) },
			{ "prUserId", new Integer(Types.BIGINT) },
			{ "datePurchased", new Integer(Types.TIMESTAMP) },
			{ "howHear", new Integer(Types.VARCHAR) },
			{ "wherePurchased", new Integer(Types.VARCHAR) },
			{ "serialNumber", new Integer(Types.VARCHAR) },
			{ "productId", new Integer(Types.BIGINT) },
			{ "companyId", new Integer(Types.BIGINT) },
			{ "groupId", new Integer(Types.BIGINT) }
		};
	public static final String TABLE_SQL_CREATE = "create table PR_PRRegistration (registrationId LONG not null primary key,prUserId LONG,datePurchased DATE null,howHear VARCHAR(75) null,wherePurchased VARCHAR(75) null,serialNumber VARCHAR(75) null,productId LONG,companyId LONG,groupId LONG)";
	public static final String TABLE_SQL_DROP = "drop table PR_PRRegistration";
	public static final String DATA_SOURCE = "liferayDataSource";
	public static final String SESSION_FACTORY = "liferaySessionFactory";
	public static final String TX_MANAGER = "liferayTransactionManager";
	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.entity.cache.enabled.com.inkwell.internet.productregistration.model.PRRegistration"),
			true);
	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
				"value.object.finder.cache.enabled.com.inkwell.internet.productregistration.model.PRRegistration"),
			true);
	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
				"lock.expiration.time.com.inkwell.internet.productregistration.model.PRRegistration"));

	public PRRegistrationModelImpl() {
	}

	public long getPrimaryKey() {
		return _registrationId;
	}

	public void setPrimaryKey(long pk) {
		setRegistrationId(pk);
	}

	public Serializable getPrimaryKeyObj() {
		return new Long(_registrationId);
	}

	public long getRegistrationId() {
		return _registrationId;
	}

	public void setRegistrationId(long registrationId) {
		_registrationId = registrationId;
	}

	public long getPrUserId() {
		return _prUserId;
	}

	public void setPrUserId(long prUserId) {
		_prUserId = prUserId;
	}

	public String getPrUserUuid() throws SystemException {
		return PortalUtil.getUserValue(getPrUserId(), "uuid", _prUserUuid);
	}

	public void setPrUserUuid(String prUserUuid) {
		_prUserUuid = prUserUuid;
	}

	public Date getDatePurchased() {
		return _datePurchased;
	}

	public void setDatePurchased(Date datePurchased) {
		_datePurchased = datePurchased;
	}

	public String getHowHear() {
		if (_howHear == null) {
			return StringPool.BLANK;
		}
		else {
			return _howHear;
		}
	}

	public void setHowHear(String howHear) {
		_howHear = howHear;
	}

	public String getWherePurchased() {
		if (_wherePurchased == null) {
			return StringPool.BLANK;
		}
		else {
			return _wherePurchased;
		}
	}

	public void setWherePurchased(String wherePurchased) {
		_wherePurchased = wherePurchased;
	}

	public String getSerialNumber() {
		if (_serialNumber == null) {
			return StringPool.BLANK;
		}
		else {
			return _serialNumber;
		}
	}

	public void setSerialNumber(String serialNumber) {
		_serialNumber = serialNumber;
	}

	public long getProductId() {
		return _productId;
	}

	public void setProductId(long productId) {
		_productId = productId;
	}

	public long getCompanyId() {
		return _companyId;
	}

	public void setCompanyId(long companyId) {
		_companyId = companyId;
	}

	public long getGroupId() {
		return _groupId;
	}

	public void setGroupId(long groupId) {
		_groupId = groupId;
	}

	public PRRegistration toEscapedModel() {
		if (isEscapedModel()) {
			return (PRRegistration)this;
		}
		else {
			return (PRRegistration)Proxy.newProxyInstance(PRRegistration.class.getClassLoader(),
				new Class[] { PRRegistration.class },
				new AutoEscapeBeanHandler(this));
		}
	}

	public ExpandoBridge getExpandoBridge() {
		if (_expandoBridge == null) {
			_expandoBridge = ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
					PRRegistration.class.getName(), getPrimaryKey());
		}

		return _expandoBridge;
	}

	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		getExpandoBridge().setAttributes(serviceContext);
	}

	public Object clone() {
		PRRegistrationImpl prRegistrationImpl = new PRRegistrationImpl();

		prRegistrationImpl.setRegistrationId(getRegistrationId());

		prRegistrationImpl.setPrUserId(getPrUserId());

		prRegistrationImpl.setDatePurchased(getDatePurchased());

		prRegistrationImpl.setHowHear(getHowHear());

		prRegistrationImpl.setWherePurchased(getWherePurchased());

		prRegistrationImpl.setSerialNumber(getSerialNumber());

		prRegistrationImpl.setProductId(getProductId());

		prRegistrationImpl.setCompanyId(getCompanyId());

		prRegistrationImpl.setGroupId(getGroupId());

		return prRegistrationImpl;
	}

	public int compareTo(PRRegistration prRegistration) {
		long pk = prRegistration.getPrimaryKey();

		if (getPrimaryKey() < pk) {
			return -1;
		}
		else if (getPrimaryKey() > pk) {
			return 1;
		}
		else {
			return 0;
		}
	}

	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}

		PRRegistration prRegistration = null;

		try {
			prRegistration = (PRRegistration)obj;
		}
		catch (ClassCastException cce) {
			return false;
		}

		long pk = prRegistration.getPrimaryKey();

		if (getPrimaryKey() == pk) {
			return true;
		}
		else {
			return false;
		}
	}

	public int hashCode() {
		return (int)getPrimaryKey();
	}

	public String toString() {
		StringBundler sb = new StringBundler(19);

		sb.append("{registrationId=");
		sb.append(getRegistrationId());
		sb.append(", prUserId=");
		sb.append(getPrUserId());
		sb.append(", datePurchased=");
		sb.append(getDatePurchased());
		sb.append(", howHear=");
		sb.append(getHowHear());
		sb.append(", wherePurchased=");
		sb.append(getWherePurchased());
		sb.append(", serialNumber=");
		sb.append(getSerialNumber());
		sb.append(", productId=");
		sb.append(getProductId());
		sb.append(", companyId=");
		sb.append(getCompanyId());
		sb.append(", groupId=");
		sb.append(getGroupId());
		sb.append("}");

		return sb.toString();
	}

	public String toXmlString() {
		StringBundler sb = new StringBundler(31);

		sb.append("<model><model-name>");
		sb.append(
			"com.inkwell.internet.productregistration.model.PRRegistration");
		sb.append("</model-name>");

		sb.append(
			"<column><column-name>registrationId</column-name><column-value><![CDATA[");
		sb.append(getRegistrationId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>prUserId</column-name><column-value><![CDATA[");
		sb.append(getPrUserId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>datePurchased</column-name><column-value><![CDATA[");
		sb.append(getDatePurchased());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>howHear</column-name><column-value><![CDATA[");
		sb.append(getHowHear());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>wherePurchased</column-name><column-value><![CDATA[");
		sb.append(getWherePurchased());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>serialNumber</column-name><column-value><![CDATA[");
		sb.append(getSerialNumber());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>productId</column-name><column-value><![CDATA[");
		sb.append(getProductId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>companyId</column-name><column-value><![CDATA[");
		sb.append(getCompanyId());
		sb.append("]]></column-value></column>");
		sb.append(
			"<column><column-name>groupId</column-name><column-value><![CDATA[");
		sb.append(getGroupId());
		sb.append("]]></column-value></column>");

		sb.append("</model>");

		return sb.toString();
	}

	private long _registrationId;
	private long _prUserId;
	private String _prUserUuid;
	private Date _datePurchased;
	private String _howHear;
	private String _wherePurchased;
	private String _serialNumber;
	private long _productId;
	private long _companyId;
	private long _groupId;
	private transient ExpandoBridge _expandoBridge;
}