/**
 * Copyright (c) 2000-2010 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.inkwell.internet.slogan.model;

import com.liferay.portal.kernel.annotation.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Slogan service. Represents a row in the &quot;Slogan_Slogan&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link com.inkwell.internet.slogan.model.impl.SloganModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link com.inkwell.internet.slogan.model.impl.SloganImpl}.
 * </p>
 *
 * <p>
 * Never modify or reference this interface directly. All methods that expect a slogan model instance should use the {@link Slogan} interface instead.
 * </p>
 *
 * @author Rich Sezov
 * @see Slogan
 * @see com.inkwell.internet.slogan.model.impl.SloganImpl
 * @see com.inkwell.internet.slogan.model.impl.SloganModelImpl
 * @generated
 */
public interface SloganModel extends BaseModel<Slogan> {
	/**
	 * Gets the primary key of this slogan.
	 *
	 * @return the primary key of this slogan
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this slogan
	 *
	 * @param pk the primary key of this slogan
	 */
	public void setPrimaryKey(long pk);

	/**
	 * Gets the uuid of this slogan.
	 *
	 * @return the uuid of this slogan
	 */
	@AutoEscape
	public String getUuid();

	/**
	 * Sets the uuid of this slogan.
	 *
	 * @param uuid the uuid of this slogan
	 */
	public void setUuid(String uuid);

	/**
	 * Gets the slogan id of this slogan.
	 *
	 * @return the slogan id of this slogan
	 */
	public long getSloganId();

	/**
	 * Sets the slogan id of this slogan.
	 *
	 * @param sloganId the slogan id of this slogan
	 */
	public void setSloganId(long sloganId);

	/**
	 * Gets the slogan date of this slogan.
	 *
	 * @return the slogan date of this slogan
	 */
	public Date getSloganDate();

	/**
	 * Sets the slogan date of this slogan.
	 *
	 * @param sloganDate the slogan date of this slogan
	 */
	public void setSloganDate(Date sloganDate);

	/**
	 * Gets the slogan text of this slogan.
	 *
	 * @return the slogan text of this slogan
	 */
	@AutoEscape
	public String getSloganText();

	/**
	 * Sets the slogan text of this slogan.
	 *
	 * @param sloganText the slogan text of this slogan
	 */
	public void setSloganText(String sloganText);

	/**
	 * Gets the status of this slogan.
	 *
	 * @return the status of this slogan
	 */
	public int getStatus();

	/**
	 * Sets the status of this slogan.
	 *
	 * @param status the status of this slogan
	 */
	public void setStatus(int status);

	/**
	 * Gets the status by user id of this slogan.
	 *
	 * @return the status by user id of this slogan
	 */
	public long getStatusByUserId();

	/**
	 * Sets the status by user id of this slogan.
	 *
	 * @param statusByUserId the status by user id of this slogan
	 */
	public void setStatusByUserId(long statusByUserId);

	/**
	 * Gets the status by user uuid of this slogan.
	 *
	 * @return the status by user uuid of this slogan
	 * @throws SystemException if a system exception occurred
	 */
	public String getStatusByUserUuid() throws SystemException;

	/**
	 * Sets the status by user uuid of this slogan.
	 *
	 * @param statusByUserUuid the status by user uuid of this slogan
	 */
	public void setStatusByUserUuid(String statusByUserUuid);

	/**
	 * Gets the status by user name of this slogan.
	 *
	 * @return the status by user name of this slogan
	 */
	@AutoEscape
	public String getStatusByUserName();

	/**
	 * Sets the status by user name of this slogan.
	 *
	 * @param statusByUserName the status by user name of this slogan
	 */
	public void setStatusByUserName(String statusByUserName);

	/**
	 * Gets the status date of this slogan.
	 *
	 * @return the status date of this slogan
	 */
	public Date getStatusDate();

	/**
	 * Sets the status date of this slogan.
	 *
	 * @param statusDate the status date of this slogan
	 */
	public void setStatusDate(Date statusDate);

	/**
	 * Gets the company id of this slogan.
	 *
	 * @return the company id of this slogan
	 */
	public long getCompanyId();

	/**
	 * Sets the company id of this slogan.
	 *
	 * @param companyId the company id of this slogan
	 */
	public void setCompanyId(long companyId);

	/**
	 * Gets the group id of this slogan.
	 *
	 * @return the group id of this slogan
	 */
	public long getGroupId();

	/**
	 * Sets the group id of this slogan.
	 *
	 * @param groupId the group id of this slogan
	 */
	public void setGroupId(long groupId);

	/**
	 * Gets the user id of this slogan.
	 *
	 * @return the user id of this slogan
	 */
	public long getUserId();

	/**
	 * Sets the user id of this slogan.
	 *
	 * @param userId the user id of this slogan
	 */
	public void setUserId(long userId);

	/**
	 * Gets the user uuid of this slogan.
	 *
	 * @return the user uuid of this slogan
	 * @throws SystemException if a system exception occurred
	 */
	public String getUserUuid() throws SystemException;

	/**
	 * Sets the user uuid of this slogan.
	 *
	 * @param userUuid the user uuid of this slogan
	 */
	public void setUserUuid(String userUuid);

	/**
	 * Determines if this slogan is approved.
	 *
	 * @return <code>true</code> if this slogan is approved; <code>false</code> otherwise
	 */
	public boolean isApproved();

	/**
	 * Determines if this slogan is a draft.
	 *
	 * @return <code>true</code> if this slogan is a draft; <code>false</code> otherwise
	 */
	public boolean isDraft();

	/**
	 * Determines if this slogan is expired.
	 *
	 * @return <code>true</code> if this slogan is expired; <code>false</code> otherwise
	 */
	public boolean isExpired();

	/**
	 * Determines if this slogan is pending.
	 *
	 * @return <code>true</code> if this slogan is pending; <code>false</code> otherwise
	 */
	public boolean isPending();

	/**
	 * Gets a copy of this slogan as an escaped model instance by wrapping it with an {@link com.liferay.portal.kernel.bean.AutoEscapeBeanHandler}.
	 *
	 * @return the escaped model instance
	 * @see com.liferay.portal.kernel.bean.AutoEscapeBeanHandler
	 */
	public Slogan toEscapedModel();

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public void setEscapedModel(boolean escapedModel);

	public Serializable getPrimaryKeyObj();

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(Slogan slogan);

	public int hashCode();

	public String toString();

	public String toXmlString();
}